<?php

namespace Teknisa\TCO\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\FilterCriteria;

class Tco00200Porcionamento extends \Teknisa\GER\Controllers\TeknisaCrud {
    
    protected $novoCodigo;
    protected $crudService;
    protected $environment;
    protected $entityManager;
    protected $dataSourceManager;
    protected $dataSourceName = 'porcionamento';
    protected $service;

    public function __construct($crudService, $parameterBag, $environment, $entityManager, $novoCodigo, $dataSourceManager, $service) {
        $this->novoCodigo        = $novoCodigo;
        $this->crudService       = $crudService;
        $this->environment       = $environment;
        $this->entityManager     = $entityManager;
        $this->dataSourceManager = $dataSourceManager;
        $this->service           = $service;
    }
    
    public function salvaPorcionamento(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = 'porcionamento';
        $rows = $this->crudService->getRowsToSave($request, $this->dataSourceName);
        
        $filterCriteria = new FilterCriteria($this->dataSourceName);
        $filterCriteria->addCondition('CDPORCIONAMENTO', $rows[0]['CDPORCIONAMENTO']);
        $filterCriteria->addCondition('NRORG', $rows[0]['NRORG']);
        
        $dataSet = $this->dataSourceManager->findBy($filterCriteria);
        $codigo = $dataSet->getRows();
        
        if(strlen($rows[0]['CDPORCIONAMENTO']) !== 5 || !ctype_digit($rows[0]['CDPORCIONAMENTO'])){
            $message = array(
                'error' => 'Código inválido!'
            );
            $response->addDataSet(new DataSet ('result', $message));
            
        }else{
            
            if(!$codigo || $codigo[0]['NRPORCIONAMENTO'] == $rows[0]['NRPORCIONAMENTO']){
                if($rows[0]['__is_new']){
                    $rows[0]['NRPORCIONAMENTO'] = $this->novoCodigo->getCodeByTableName('PORCIONAMENTO', $this->environment->getNrOrgTrab());
                }
                $this->crudService->save($this->dataSourceName, $rows);
                $message = array(
                    'success' => 'Sucesso!',
                    'code'    => $rows[0]['NRPORCIONAMENTO']
                );
                $response->addDataSet(new DataSet ('result', $message));
            }else{
                
                $message = array(
                    'error' => 'Código já cadastrado!'
                );
                $response->addDataSet(new DataSet ('result', $message));
            }
        }
    }
    
    public function apagaPorcionamento(DTO\Request $request, DTO\Response $response) {
        $porcionamento = $request->getDataSet()->getRows();
        $porcionamentosUtilizados = $this->service->retornaPorcionamentosVinculados($porcionamento); 
        
        if(empty($porcionamentosUtilizados)){
            $rows = $this->crudService->getRowsToDelete($request, 'porcionamento');
            $dataSet = new DataSet("porcionamento", $rows);
    		$this->crudService->delete($response, $dataSet);
    		
            $response->addDataSet(new DataSet("porcionamentosUtilizados", array()));
        } else {
            $response->addDataSet(new DataSet("porcionamentosUtilizados", $porcionamentosUtilizados));
        }
        
        
    }
    
    public function adicionarRelPorcioGrTipoPr(DTO\Request $request, DTO\Response $response) {
        $rows = $request->getDataSet()->getRows();
        $this->service->adicionarRelPorcioGrTipoPr($rows);
    }
    
    public function apagarRelPorcioGrTipoPr(DTO\Request $request, DTO\Response $response) {
        $rows = $request->getDataSet()->getRows();
        $this->service->apagarRelPorcioGrTipoPr($rows);
    }
}